package hu.bute.daai.amorg.examples;

import java.io.File;
import java.io.FileInputStream;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.Toast;

public class CameraSimpleDemoActivity extends Activity {

	private final int CAMERA_IMAGE_REQUEST = 101;
	private final String IMAGEPATH = Environment.getExternalStorageDirectory()
			.getAbsolutePath() + "/tmp_image.jpg";

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		Button btnTakePhoto = (Button) findViewById(R.id.btnTakePhoto);
		btnTakePhoto.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				File imageFile = new File(IMAGEPATH);
				Uri imageFileUri = Uri.fromFile(imageFile);

				Intent cameraIntent = new Intent(
						android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
				cameraIntent.putExtra(android.provider.MediaStore.EXTRA_OUTPUT,
						imageFileUri);
				startActivityForResult(cameraIntent, CAMERA_IMAGE_REQUEST);
			}
		});
	}

	// Visszatrs a kamertl
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (requestCode == CAMERA_IMAGE_REQUEST) {
			if (resultCode == RESULT_OK) {
				try {
					File imageFile = new File(IMAGEPATH);
					FileInputStream fis = new FileInputStream(imageFile);
					Bitmap img = BitmapFactory.decodeStream(fis);
					ImageView ivPhoto = (ImageView) findViewById(R.id.ivPhoto);
					ivPhoto.setImageBitmap(img);
					
					//--- Arcfelismers aktivlsa
					FaceView fv= new FaceView(this, img);
					setContentView(fv);
				} catch (Exception e) {
				}
			} else if (resultCode == RESULT_CANCELED) {
				Toast.makeText(this, getString(R.string.txtPhotoCancelled), Toast.LENGTH_LONG).show();
			}
		}
	}
}