package hu.bute.daai.amorg.examples;

import android.app.Activity;
import android.app.Fragment;
import android.os.Bundle;
import android.util.AttributeSet;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

public class DetailsFragment extends Fragment {
	
	private int mIndex = 0;

	public static DetailsFragment newInstance(int index) {
        Log.v(FragmentBasicActivity.TAG, "DetailsFragment newInstance(" + index + ")");

        DetailsFragment df = new DetailsFragment();

        // index argumentum elmentse,
        // itt mg hhatunk setArguments()-et
		Bundle args = new Bundle();
		args.putInt("index", index);
		df.setArguments(args);
		return df;
	}
	
	public static DetailsFragment newInstance(Bundle bundle) {
		int index = bundle.getInt("index", 0);
        return newInstance(index);
	}

    @Override
    public void onInflate(Activity activity, AttributeSet attrs, Bundle savedInstanceState) {
    	Log.v(FragmentBasicActivity.TAG,
    			"in DetailsFragment onInflate. AttributeSet:");
    	for(int i=0; i<attrs.getAttributeCount(); i++)
            Log.v(FragmentBasicActivity.TAG, "    " + attrs.getAttributeName(i) +
            		" = " + attrs.getAttributeValue(i));
    	super.onInflate(activity, attrs, savedInstanceState);
    }

	@Override
    public void onAttach(Activity myActivity) {
    	Log.v(FragmentBasicActivity.TAG, "DetailsFragment onAttach(); activity: " +
    			myActivity);
    	super.onAttach(myActivity);
    }

    @Override
    public void onCreate(Bundle myBundle) {
    	Log.v(FragmentBasicActivity.TAG, "DetailsFragment onCreate(). Bundle:");
    	if(myBundle != null) {
            for(String key : myBundle.keySet()) {
                Log.v(FragmentBasicActivity.TAG, "    " + key);
            }
    	}
    	else {
            Log.v(FragmentBasicActivity.TAG, "    myBundle null");
    	}
    	super.onCreate(myBundle);

    	mIndex = getArguments().getInt("index", 0);
    }

    public int getShownIndex() {
    	return mIndex;
    }

	@Override
	public View onCreateView(LayoutInflater inflater,
			ViewGroup container, Bundle savedInstanceState) {
	    Log.v(FragmentBasicActivity.TAG, "DetailsFragment onCreateView(). container = " +
	    		container);
	    if(container == null) {
	    	Log.v(FragmentBasicActivity.TAG, "container null");
	    	return null;
	    }
	
	    View v = inflater.inflate(R.layout.details, container, false);
		TextView text1 = (TextView) v.findViewById(R.id.textTodo);
		text1.setText(Todos.TODODETAILS[ mIndex ] );
		return v;
	}

    @Override
    public void onActivityCreated(Bundle savedState) {
    	Log.v(FragmentBasicActivity.TAG,
    			"DetailsFragment onActivityCreated(). savedState:");
    	if(savedState != null) {
            for(String key : savedState.keySet()) {
                Log.v(FragmentBasicActivity.TAG, "    " + key);
            }
    	}
    	else {
            Log.v(FragmentBasicActivity.TAG, "    savedState null");
    	}
        super.onActivityCreated(savedState);
    }

    @Override
    public void onStart() {
    	Log.v(FragmentBasicActivity.TAG, "DetailsFragment onStart()");
    	super.onStart();
    }

    @Override
    public void onResume() {
    	Log.v(FragmentBasicActivity.TAG, "DetailsFragment onResume()");
    	super.onResume();
    }

    @Override
    public void onPause() {
    	Log.v(FragmentBasicActivity.TAG, "DetailsFragment onPause()");
    	super.onPause();
    }

    @Override
    public void onSaveInstanceState(Bundle outState) {
    	Log.v(FragmentBasicActivity.TAG, "DetailsFragment onSaveInstanceState()");
        super.onSaveInstanceState(outState);
    }

    @Override
    public void onStop() {
    	Log.v(FragmentBasicActivity.TAG, "DetailsFragment onStop()");
    	super.onStop();
    }

    @Override
    public void onDestroyView() {
    	Log.v(FragmentBasicActivity.TAG, "DetailsFragment onDestroyView(), view = " +
    			getView());
    	super.onDestroyView();
    }

    @Override
    public void onDestroy() {
    	Log.v(FragmentBasicActivity.TAG, "DetailsFragment onDestroy()");
    	super.onDestroy();
    }

    @Override
    public void onDetach() {
    	Log.v(FragmentBasicActivity.TAG, "DetailsFragment onDetach()");
    	super.onDetach();
    }
}