package hu.bute.daai.amorg.examples;

import android.app.Activity;
import android.app.Fragment;
import android.app.FragmentManager;
import android.app.FragmentTransaction;
import android.content.Intent;
import android.content.res.Configuration;
import android.os.Bundle;
import android.util.Log;

public class FragmentBasicActivity extends Activity {
    public static final String TAG = "Todo";

    @Override
    public void onCreate(Bundle savedInstanceState) {
		Log.v(TAG, "MainActivity onCreate()");
        super.onCreate(savedInstanceState);
		FragmentManager.enableDebugLogging(true);
        setContentView(R.layout.main);
    }

    @Override
    public void onAttachFragment(Fragment fragment) {
		Log.v(TAG, "MainActivity onAttachFragment. fragment I: " + fragment.getId());
        super.onAttachFragment(fragment);
    }

    @Override
    public void onStart() {
		Log.v(TAG, "MainActivity onStart()");
    	super.onStart();
    }
    
    @Override
    public void onResume() {
		Log.v(TAG, "MainActivity onResume()");
    	super.onResume();
    }
    
    @Override
    public void onPause() {
		Log.v(TAG, "MainActivity onPause()");
    	super.onPause();
    }
    
    @Override
    public void onStop() {
		Log.v(TAG, "MainActivity onStop()");
    	super.onStop();
    }
    
    @Override
    public void onSaveInstanceState(Bundle outState) {
    	Log.v(TAG, "MainActivity onSaveInstanceState()");
        super.onSaveInstanceState(outState);
    }

    @Override
    public void onDestroy() {
		Log.v(TAG, "MainActivity onDestroy()");
    	super.onDestroy();
    }
    
    public boolean isLandscape() {
        return getResources().getConfiguration().orientation == Configuration.ORIENTATION_LANDSCAPE;
    }

    // Todo rszletek megjelentse
    public void showTodo(int index) {
    	Log.v(TAG, "MainActivity showTodo(" + index + ")");
    	// fekv md
        if (isLandscape()) {
            DetailsFragment details = (DetailsFragment)
                    getFragmentManager().findFragmentById(R.id.tododetail);
            if (details == null || details.getShownIndex() != index) {
                // j fragment ltrehozsa
                details = DetailsFragment.newInstance(index);
                
                // j fragment megjelentse
                FragmentTransaction ft = getFragmentManager().beginTransaction();
                //ft.setCustomAnimations(R.animator.fragment_open_enter,
                //		R.animator.fragment_open_exit);
                ft.setCustomAnimations(R.animator.todo_in,
                		R.animator.todo_out);
                //ft.setCustomAnimations(R.animator.fade_in,
                //		R.animator.fade_out);
                //ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_FADE);
                ft.replace(R.id.tododetail, details);
                ft.addToBackStack(TAG);
                ft.commit();
            }

        } else {
            // Egyb esetben j Activity indtsa a rszletek megjelentshez
            Intent intent = new Intent();
            intent.setClass(this, DetailsActivity.class);
            intent.putExtra("index", index);
            startActivity(intent);
        }
    }
}