package hu.bute.daai.amorg.examples;

import android.app.Activity;
import android.app.ListFragment;
import android.os.Bundle;
import android.util.AttributeSet;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class TodosFragment extends ListFragment {
    private FragmentBasicActivity myActivity = null;
    int mSelectedTodoPosition = 0;

    @Override
    public void onInflate(Activity activity, AttributeSet attrs, Bundle bundle) {
    	Log.v(FragmentBasicActivity.TAG,
    			"TodosFragment onInflate(). AttributeSet:");
    	for(int i=0; i<attrs.getAttributeCount(); i++) {
            Log.v(FragmentBasicActivity.TAG, "    " + attrs.getAttributeName(i) +
            		" = " + attrs.getAttributeValue(i));
    	}
    	super.onInflate(activity, attrs, bundle);
    }

    @Override
    public void onAttach(Activity myActivity) {
    	Log.v(FragmentBasicActivity.TAG, "TodosFragment onAttach(); activity: " + myActivity);
    	super.onAttach(myActivity);
    	this.myActivity = (FragmentBasicActivity)myActivity;
    }

    @Override
    public void onCreate(Bundle bundle) {
    	Log.v(FragmentBasicActivity.TAG, "TodosFragment onCreate(). Bundle:");
    	if(bundle != null) {
            for(String key : bundle.keySet()) {
                Log.v(FragmentBasicActivity.TAG, "    " + key);
            }
    	}
    	else {
            Log.v(FragmentBasicActivity.TAG, "    myBundle null");
    	}
    	super.onCreate(bundle);
        if (bundle != null) {
            // Kivlasztott index
            mSelectedTodoPosition = bundle.getInt("curIndex", 0);
        }
    }

    @Override
    public View onCreateView(LayoutInflater myInflater, ViewGroup container, Bundle bundle) {
    	Log.v(FragmentBasicActivity.TAG, "TodosFragment onCreateView(). container " + container);
    	return super.onCreateView(myInflater, container, bundle);
    }
    
    @Override
    public void onActivityCreated(Bundle bundle) {
    	Log.v(FragmentBasicActivity.TAG, "TodosFragment onActivityCreated(). bundle:");
    	if(bundle != null) {
            for(String key : bundle.keySet()) {
                Log.v(FragmentBasicActivity.TAG, "    " + key);
            }
    	}
    	else {
            Log.v(FragmentBasicActivity.TAG, "    bundle null");
    	}
        super.onActivityCreated(bundle);

        // Lista feltltse
        setListAdapter(new ArrayAdapter<String>(getActivity(),
                android.R.layout.simple_list_item_1,
                Todos.TODOTITLES));

        ListView lv = getListView();
        lv.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
        lv.setSelection(mSelectedTodoPosition);

        myActivity.showTodo(mSelectedTodoPosition);
    }

    @Override
    public void onStart() {
    	Log.v(FragmentBasicActivity.TAG, "TodosFragment onStart()");
    	super.onStart();
    }

    @Override
    public void onResume() {
    	Log.v(FragmentBasicActivity.TAG, "TodosFragment onResume()");
    	super.onResume();
    }

    @Override
    public void onPause() {
    	Log.v(FragmentBasicActivity.TAG, "TodosFragment onPause()");
    	super.onPause();
    }

    @Override
    public void onSaveInstanceState(Bundle bundle) {
    	Log.v(FragmentBasicActivity.TAG, "TodosFragment onSaveInstanceState()");
        super.onSaveInstanceState(bundle);
        bundle.putInt("curIndex", mSelectedTodoPosition);
    }

    @Override
    public void onListItemClick(ListView l, View v, int pos, long id) {
    	Log.v(FragmentBasicActivity.TAG, "TodosFragment onListItemClick(). pos = "
    			+ pos);
        myActivity.showTodo(pos);
    	mSelectedTodoPosition = pos;
    }

    @Override
    public void onStop() {
    	Log.v(FragmentBasicActivity.TAG, "TodosFragment onStop()");
    	super.onStop();
    }

    @Override
    public void onDestroyView() {
    	Log.v(FragmentBasicActivity.TAG, "TodosFragment onDestroyView()");
    	super.onDestroyView();
    }

    @Override
    public void onDestroy() {
    	Log.v(FragmentBasicActivity.TAG, "TodosFragment onDestroy()");
    	super.onDestroy();
    }

    @Override
    public void onDetach() {
    	Log.v(FragmentBasicActivity.TAG, "TodosFragment onDetach()");
    	super.onDetach();
    	myActivity = null;
    }
}
