package sze.haromszogesfeladat;

/*
 Haromszog. java
 Egy a, b, c oldalhosszúságaival adott háromszögrõl eldöntjük, hogy a háromszög egyenlõtlenségnek eleget tesz-e, azaz szerkeszthetõ-e?
 */
public class Haromszog {

	// adatrejtés elve miatt csak az osztály számára tesszük láthatóvá a saját
	// változókat
	private double a;
	private double b;
	private double c;

	// Konstruktor a bemenő paraméterekkel
	public Haromszog(double a_, double b_, double c_) {
		a = a_;
		b = b_;
		c = c_;
	}

	public double getKerulet() {
		return a + b + c;
	}

	public double getTerulet() {
		double s = (a + b + c) / 2.;
		return (Math.sqrt(s * (s - a) * (s - b) * (s - c)));
	}

	// a háromszög egyenlõtlenség számító logikai típ. függvény
	public boolean isSzerkesztheto() {
		return (a + b > c && b + c > a && c + a > b);
	}

	public String toString() {

		return "A hromszg "+ (isSzerkesztheto() 
						? "szerkeszthet, terlete: "
						+ getTerulet() + ". " : "nem szerkeszthet!");

	}
}