package hu.bute.daai.amorg.examples;

import java.io.IOException;
import java.io.InputStream;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.HttpGet;

import android.app.ProgressDialog;
import android.content.Context;
import android.net.http.AndroidHttpClient;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.Toast;

public class HttpGetAsyncTask extends AsyncTask<String, Integer, String> {

	private Context context = null;
	private ProgressDialog progressDialog = null;
	private long responseLength;
	
	public HttpGetAsyncTask(Context context) {
	    this.context = context; 
	}
	
	@Override
	protected void onPreExecute() {
		progressDialog = new ProgressDialog(this.context);
	    progressDialog.setMessage("Krem vrjon...");
	    progressDialog.show();
	}
	
	@Override
	protected void onCancelled() {
		// TODO Auto-generated method stub
		super.onCancelled();
	}

	@Override
	protected String doInBackground(String... urls) {
		String retVal = "";
		AndroidHttpClient httpClient = AndroidHttpClient.newInstance("Android");
		HttpGet httpGet = new HttpGet(urls[0]);
		InputStream is = null;
		try {
			HttpResponse response = httpClient.execute(httpGet);
			if (response.getStatusLine().getStatusCode() == HttpStatus.SC_OK) {
				HttpEntity entity = response.getEntity();
				responseLength = entity.getContentLength();
				if (entity != null) {
					is = entity.getContent();
					StringBuilder sb = new StringBuilder();
					int chIn;
					int idx = 0;
					while ((chIn=is.read()) != -1) {
						sb.append((char)chIn);
						publishProgress(++idx);
					}
					retVal = sb.toString();
				}
			}
		} catch (Exception e) {
			retVal = "Error: "+e.getMessage();
		} finally {
			if (is != null) {
				try {
					is.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if (httpClient != null)
				httpClient.close();
		}
		return retVal;
	}
	
	@Override
	protected void onProgressUpdate(Integer... values) {
		double percent = 0;
		if (responseLength != 0)
			percent = 100*values[0]/responseLength;
		Log.d("AsyncTask progress", ""+percent+" %");
	}
	
	@Override
	protected void onPostExecute(String result) {
		progressDialog.dismiss();
		Toast.makeText(context, result, Toast.LENGTH_LONG).show();
	}
}
