package amorg.android.intent;

import amorg.android.intent.entity.Todo;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

/**
 * SecondActivity
 *  
 * @author Feher Marcell [feher.marcell@aut.bme.hu]
 */
public class SecondActivity extends Activity {
	
	Button resultOkBtn, resultCancelBtn, resultAmorgBtn, resultTodoBtn, resultCustomBtn;
	EditText customReturnValue;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		super.onCreate(savedInstanceState);
		setContentView(R.layout.secondlayout);
		
		resultOkBtn = (Button) findViewById(R.id.resultOK);
		resultCancelBtn = (Button) findViewById(R.id.resultCancel);
		resultAmorgBtn = (Button) findViewById(R.id.resultAmorg);
		resultTodoBtn = (Button) findViewById(R.id.resultTodo);
		resultCustomBtn = (Button) findViewById(R.id.resultCustom);
		customReturnValue = (EditText) findViewById(R.id.customReturnValue);
		
		// OnClickListener-ek inline megadasa
		resultOkBtn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				setResult(RESULT_OK);
				finish();
			}
		});
		
		resultCancelBtn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				setResult(RESULT_CANCELED);
				finish();
			}
		});
		
		resultAmorgBtn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				Intent resultIntent = new Intent();
				resultIntent.putExtra(getPackageName()+".string1", "AMORG");
				resultIntent.putExtra(getPackageName()+".string2", "Intent");
				// a resultCode-ot a MainActivity-ben definialtuk
				// azert lett public static, hogy itt hasznalhassuk
				setResult(MainActivity.RESULT_CUSTOM, resultIntent);
				finish();
			}
		});
		
		resultCustomBtn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// szovegmezo tartalmanak lekerese:
				String customValue = customReturnValue.getText().toString();
				Intent resultIntent = new Intent();
				resultIntent.putExtra(getPackageName()+".string1", customValue);
				// visszaterunk a beirt szoveggel
				setResult(MainActivity.RESULT_CUSTOM, resultIntent);
				finish();
			}
		});
		
		// egy nem inline megadott OnClickListener beallitasa
		resultTodoBtn.setOnClickListener(returnTodo);
	}
	
	// Todo peldannyal visszateres gomb esemenykezeloje az onCreate-en kivul deklaralva
	OnClickListener returnTodo = new OnClickListener() {
		
		@Override
		public void onClick(View v) {
			Intent resultIntent = new Intent();
			// ezzel fogunk visszaterni
			Todo t1 = new Todo("Cim", "Leiras", "2011.09.30", 1);
			// mivel a Todo osztaly megvalositja a Parcelable interfeszt,
			// siman berakhato putExtra-val az intent extraba
			resultIntent.putExtra(getPackageName()+".parcel", t1);
			setResult(MainActivity.RESULT_CUSTOM, resultIntent);
			finish();
		}
	};
	
	
}
