package amorg.android.intent.entity;

import android.os.Parcel;
import android.os.Parcelable;

/**
 * Todo entitas osztaly
 *  
 * @author Feher Marcell [feher.marcell@aut.bme.hu]
 */
public class Todo implements Parcelable {
	
	// Parcelable interfesz miatt belekerult dolgok az osztaly vegen
	
	// tagvaltozok
	String title, description, date;
	int priority;
	
	// konstruktor, getterek, setterek
	public Todo(String title, String description, String date, int priority) {
		super();
		this.title = title;
		this.description = description;
		this.date = date;
		this.priority = priority;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getDate() {
		return date;
	}

	public void setDate(String date) {
		this.date = date;
	}

	public int getPriority() {
		return priority;
	}

	public void setPriority(int priority) {
		this.priority = priority;
	}


	
	// Parcelable miatt kotelezo reszek:
	
	@Override
	public int describeContents() {
		return 0;
	}
	
	// Parcel-be irjuk azon tagvaltozokat, amiket majd ki akarunk olvasni
	// (gyakorlatilag mindet)
	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeString(title);
		dest.writeString(description);
		dest.writeString(date);
		dest.writeInt(priority);
	}
	
	// Parcel-bol mukodo konstruktor. A parametereket olyan sorrendben 
	// lehet kiolvasni, ahogy beleraktuk a writeToParcel-ben
	public Todo(Parcel in){
		this.title = in.readString();
		this.description= in.readString();
		this.date = in.readString();
		this.priority = in.readInt();
	}
	
	// Ez a CREATOR pontosan igy kell hogy szerepeljen, 
	// ezzel peldanyositja a Todo osztalyt az Android, 
	// amikor Parcel-bol vesszuk ki ()
	public static final Parcelable.Creator<Todo> CREATOR = new Parcelable.Creator<Todo>() {
		 public Todo createFromParcel(Parcel in) {
		     return new Todo(in);
		 }
		
		 public Todo[] newArray(int size) {
		     return new Todo[size];
		 }
	};
	
	
	
}
