package com.coreservlets.intentsexercises1;

import android.os.Bundle;
import android.view.View;
import android.app.Activity;
import android.content.Intent;

public class IntentsExercises1Launcher extends Activity {
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
    }
    
    /** Switches to the TestActivity when the associated button is clicked. */
    
    public void switchToTestActivity(View clickedButton) {
        Intent activityIntent = 
                new Intent(this, TestActivity.class);
        startActivity(activityIntent);
    }
    
    /** Switches to the SumActivity when the associated button is clicked.
     *  Does not send any data.
     */
    
    public void switchToSumActivity1(View clickedButton) {
        Intent activityIntent = 
                new Intent(this, SumActivity.class);
        startActivity(activityIntent);
    }
    
    /** Switches to the SumActivity when the associated button is clicked.
     *  Sends a Bundle with two doubles.
     */
    
    public void switchToSumActivity2(View clickedButton) {
        Bundle sumInputs = new Bundle();
        sumInputs.putDouble("input1", 5*Math.random());
        sumInputs.putDouble("input2", 10*Math.random());
        Intent activityIntent = 
                new Intent(this, SumActivity.class);
        activityIntent.putExtras(sumInputs);
        startActivity(activityIntent);
    }
    
    /** Switches to the TabbedActivity when the associated button is clicked. */
    
    public void switchToTabbedActivity(View clickedButton) {
        Intent activityIntent = 
                new Intent(this, TabbedActivity.class);
        startActivity(activityIntent);
    }
}
