package com.coreservlets.intentsexercises1;

import android.app.TabActivity;
import android.content.Intent;
import android.content.res.Resources;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Bundle;
import android.widget.TabHost;
import android.widget.TabHost.TabSpec;

public class TabbedActivity extends TabActivity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Resources resources = getResources();
        TabHost host = getTabHost();
        Intent intent1 = new Intent(this, SumActivity.class);
        Drawable tabIcon = resources.getDrawable(R.drawable.calculator);
        TabSpec tab1Spec = host.newTabSpec("Tab One")
                               .setIndicator("Sum1A", tabIcon)
                               .setContent(intent1);
        host.addTab(tab1Spec);
        Intent intent2 = new Intent(this, SumActivity.class);
        Bundle sumInputs = new Bundle();
        sumInputs.putDouble("input1", 15*Math.random());
        sumInputs.putDouble("input2", 25*Math.random());
        intent2.putExtras(sumInputs);
        TabSpec tab2Spec = host.newTabSpec("Tab Two")
                               .setIndicator("Sum1B", tabIcon)
                               .setContent(intent2);
        host.addTab(tab2Spec);
        Uri uriNoData = Uri.parse("sum://coreservlets.com/calc");
        Intent intent3 = new Intent(Intent.ACTION_VIEW, uriNoData);
        TabSpec tab3Spec = host.newTabSpec("Tab Three")
                               .setIndicator("Sum2A", tabIcon)
                               .setContent(intent3);
        host.addTab(tab3Spec);
        String address = 
                String.format("sum://coreservlets.com/calc?input1=%s&input2=%s",
                              Math.random()*35, Math.random()*45);
        Uri uriData = Uri.parse(address);
        Intent intent4 = new Intent(Intent.ACTION_VIEW, uriData);
        TabSpec tab4Spec = host.newTabSpec("Tab Four")
                               .setIndicator("Sum2B", tabIcon)
                               .setContent(intent4);
        host.addTab(tab4Spec);
    }
}