package com.coreservlets.intentsexercises2;

import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.app.Activity;
import android.content.Intent;

public class IntentsExercises2Launcher extends Activity {

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
    }
    
    /** Switches to the SumActivity when the associated button is clicked. 
     *  No data. 
     */
    public void switchToSumActivity1(View clickedButton) {
        String address = "sum://coreservlets.com/calc";
        switchToActivityByUrl(address);
    }
    
    /** Switches to the SumActivity when the associated button is clicked. 
     *  Sends data in the query parameters of the URI. 
     */
    public void switchToSumActivity2(View clickedButton) {
        String address = 
                String.format("sum://coreservlets.com/calc?input1=%s&input2=%s",
                              Math.random()*5, Math.random()*10);
        switchToActivityByUrl(address);
    }
    
    private void switchToActivityByUrl(String address) {
        Uri uri = Uri.parse(address);
        Intent intent = new Intent(Intent.ACTION_VIEW, uri);
        startActivity(intent); 
    }
}
