package hu.bute.daai.amorg.examples;

import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ToggleButton;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.OverlayItem;

public class MapDemoActivity extends MapActivity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        final MapView mapView = (MapView) findViewById(R.id.mapview);
        mapView.setBuiltInZoomControls(true);
        mapView.setTraffic(true);
        MapController mapController = mapView.getController();
        mapController.setCenter(new GeoPoint(47000000, 19000000));
        
		MyMarkers myMarkers = new MyMarkers(getResources().getDrawable(R.drawable.ic_launcher), this);
		myMarkers.addOverlay(new OverlayItem(new GeoPoint(47000000, 19000000), "cm1", "lers1"));
		myMarkers.addOverlay(new OverlayItem(new GeoPoint(47010000, 19010000), "cm2", "lers2"));
		mapView.getOverlays().add(myMarkers);
		
		mapView.getOverlays().add(new MyPath());
        
        final ToggleButton tbSatellite = (ToggleButton)findViewById(R.id.toggleButtonSatellite);
        tbSatellite.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				if (tbSatellite.isChecked())
					mapView.setSatellite(true);
				else
					mapView.setSatellite(false);
			}
		});
    }

	@Override
	protected boolean isRouteDisplayed() {
		return false;
	}
}