package hu.bute.daai.amorg.examples;

import android.app.Activity;
import android.content.Context;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.Ringtone;
import android.media.RingtoneManager;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class MediaDemoActivity extends Activity {
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		Button btnPlayTone = (Button) findViewById(R.id.btnPlayTone);
		btnPlayTone.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				playToneRingtone();
				//playToneMediaPlayer();
			}
		});
		
		Button btnVolumeDown = (Button) findViewById(R.id.btnVolumeDown);
		btnVolumeDown.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				volumeDown();
			}
		});

	}
	
	private void playToneRingtone() {
		Uri uriNotif = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_ALARM);
		Ringtone r = RingtoneManager.getRingtone(getApplicationContext(), uriNotif);
		r.setStreamType(AudioManager.STREAM_MUSIC);
		r.play();
	}

	@SuppressWarnings("unused")
	private void playToneMediaPlayer() {
		try {
			Uri notificationTone = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
			MediaPlayer mMediaPlayer = new MediaPlayer();
			mMediaPlayer.setDataSource(MediaDemoActivity.this, notificationTone);
			mMediaPlayer.setAudioStreamType(AudioManager.STREAM_MUSIC);
			mMediaPlayer.setLooping(false);
			mMediaPlayer.prepare();
			mMediaPlayer.start();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void volumeDown() {
		AudioManager audioManager = (AudioManager) getSystemService(Context.AUDIO_SERVICE);
		audioManager.setStreamVolume(AudioManager.STREAM_RING, 100, AudioManager.FLAG_SHOW_UI);
	}

}