package sze.menukezeles;

import java.util.Locale;

import android.os.Bundle;
import android.app.Activity;
import android.graphics.Color;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;

public class MainActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}

	// menpontok kezelse
	public boolean onOptionsItemSelected(MenuItem valasztas) {

		// kezel rsz
		switch (valasztas.getItemId()) {
		// szveg szne
		case R.id.menu_colour_B:
			szovegszin(R.id.szoveg, Color.BLUE);
			break;
		case R.id.menu_colour_R:
			szovegszin(R.id.szoveg, Color.RED);
			break;
		case R.id.menu_colour_G:
			szovegszin(R.id.szoveg, Color.GREEN);
			break;
		// nyelv
		case R.id.menu_lang_en:
		case R.id.menu_lang_hu:
			nyelvvaltas(valasztas.getItemId()); // mit is vlasztottam
			break;
		}
		// visszatrs
		return super.onOptionsItemSelected(valasztas);

	}

	// egy szveges erforrs szne
	private void szovegszin(int id, int szin) {
		try {
			((TextView) findViewById(id)).setTextColor(szin);
		} catch (Exception e) {
			Log.e("HIBA", "hibs vezrl sznezs");
		}
	}

	private void nyelvvaltas(int mire) {
		
		/*Locale.setDefault(
			new Locale((mire==R.id.menu_lang_en)?"en": "hu"));
		*/
		Log.i("Nyelv", " "+mire);
	}
}
