package hu.bute.daai.amorg.examples;

import android.app.Activity;
import android.media.MediaPlayer;
import android.media.MediaPlayer.OnCompletionListener;
import android.media.MediaPlayer.OnPreparedListener;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class Mp3PlayerActivity extends Activity implements OnPreparedListener, OnCompletionListener {
	private MediaPlayer mp;
	private Button btnStart;
	private Button btnPause;
	private Button btnStop;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		
		btnStart = (Button)findViewById(R.id.btnStart);
		btnStart.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				mp.start();
			}
		});
		btnPause = (Button)findViewById(R.id.btnPause);
		btnPause.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				mp.pause();
			}
		});
		btnStop = (Button)findViewById(R.id.btnStop);
		btnStop.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				mp.seekTo(0);
				mp.pause();
			}
		});
		
		preparePlayer();
	}

	@Override
	protected void onStop() {
		super.onStop();
		if (mp != null) {
			try {
				mp.stop();
				mp.release();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	private void preparePlayer() {
		try {
			mp = MediaPlayer.create(this, R.raw.test);
			mp.setOnPreparedListener(this);
			mp.setOnCompletionListener(this);
		} catch (Exception e) {
		}
	}

	public void onPrepared(MediaPlayer mp) {
		btnStart.setEnabled(true);
		btnPause.setEnabled(true);
		btnStop.setEnabled(true);
	}

	@Override
	public void onCompletion(MediaPlayer mp) {
		Toast.makeText(this, "Media finished!", Toast.LENGTH_LONG).show();
	}
}