package com.coreservlets.multithreadingexercises2;

import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.app.Activity;

import java.util.concurrent.*;

public class Flipper1Activity extends Activity {
    private int mMaxConsecutiveHeads = 0;
    TextView mFlipResults;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_flipper1);
        mFlipResults = (TextView)findViewById(R.id.flip_results);
    }
    
    public void startFlipping(View clickedButton) {
        mMaxConsecutiveHeads = 0;
        int poolSize = 10;
        ExecutorService tasks = 
          Executors.newFixedThreadPool(poolSize);
        for(int i=0; i<5; i++) {
          tasks.execute(new CoinFlipper());
        }
        tasks.shutdown(); // No more new tasks can be added
        try {
          tasks.awaitTermination(30, TimeUnit.SECONDS);
        } catch(InterruptedException ie) {}
        mFlipResults.setText("Max consecutive heads: " + mMaxConsecutiveHeads);
    }

    private class CoinFlipper implements Runnable {
        public void run() {
          int numHeads = 0;
          for(int i=0; i<1000; i++) {
            double coin = Math.random();
            if (coin < 0.5) {
              numHeads = numHeads + 1;
            } else {
              numHeads = 0;
            }
            synchronized(Flipper1Activity.this) {
                if (numHeads > mMaxConsecutiveHeads) {
                    mMaxConsecutiveHeads = numHeads;
                }
            }
          }
        }
      }
}
