package com.coreservlets.multithreadingexercises2;

import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.app.Activity;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class Flipper2Activity extends Activity {
    private int mMaxConsecutiveHeads = 0;
    TextView mFlipResults;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_flipper2);
        mFlipResults = (TextView)findViewById(R.id.flip_results);
    }

    public void startFlipping(View clickedButton) {
        mMaxConsecutiveHeads = 0;
        int poolSize = 10;
        ExecutorService tasks = 
          Executors.newFixedThreadPool(poolSize);
        for(int i=0; i<5; i++) {
          tasks.execute(new CoinFlipper());
        }
        tasks.shutdown(); // No more new tasks can be added
    }
    
    private class CoinFlipper implements Runnable {
        public void run() {
          int numHeads = 0;
          for(int i=0; i<1000; i++) {
            double coin = Math.random();
            if (coin < 0.5) {
              numHeads = numHeads + 1;
            } else {
              numHeads = 0;
            }
            synchronized(Flipper2Activity.this) {
                if (numHeads > mMaxConsecutiveHeads) {
                    mMaxConsecutiveHeads = numHeads;
                    mFlipResults.post(new ViewUpdater(mMaxConsecutiveHeads));
                }
            }
            ThreadUtils.pause(0.01);
          }
        }
      }
    
    private class ViewUpdater implements Runnable {
        private int mCount;
        
        public ViewUpdater(int count) {
            mCount = count;
        }
        
        public void run() {
            mFlipResults.setText("Max consecutive heads: " + mCount);
        }
    }
}
