package hu.bute.daai.amorg.examples;

import java.util.Date;

import android.app.Activity;
import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class MyLocationActivity extends Activity implements LocationListener {

	private TextView tvStatus;
	private LocationManager lm;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		tvStatus = (TextView) findViewById(R.id.tvStatus);
		Button btnStart = (Button) findViewById(R.id.btnStart);
		btnStart.setOnClickListener(new OnClickListener() {
			public void onClick(View arg0) {
				startLocationUpdate();
			}
		});
	}

	@Override
	protected void onStop() {
		super.onStop();
		if (lm != null) {
			lm.removeUpdates(this);
		}
	}

	protected void startLocationUpdate() {
		LocationManager lm = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
		lm.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, this);
		lm.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 0, 0, this);
	}

	public void onLocationChanged(Location location) {
		if (location != null) {
			tvStatus.append(new Date(location.getTime()).toString()+ "," +
					location.getLatitude() + ","
					+ location.getLongitude()+"\n");
		}
	}

	public void onProviderDisabled(String provider) {
		// TODO esemny jelzse
	}

	public void onProviderEnabled(String provider) {
		// TODO esemny jelzse
	}

	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO esemny jelzse
	}
}