#include <string.h>
#include <jni.h>

#include <android/log.h>
#include <android/sensor.h>
#include <android/looper.h>

#define LOGI(...) ((void)__android_log_print(ANDROID_LOG_INFO, "native-module", __VA_ARGS__))

struct engine {
	ASensorManager* sensorManager;
	const ASensor* lightSensor;
	ASensorEventQueue* sensorEventQueue;
};

struct engine engine;
float lightValue;

static int get_sensor_data(int fd, int events, void* data);

jfloat Java_hu_bute_daai_amorg_examples_NativeSensorLib_getLightSensorValue() {
	return lightValue;
}

void Java_hu_bute_daai_amorg_examples_NativeSensorLib_startLightSensor(
		JNIEnv* env, jobject thiz) {
	LOGI("Light sensor inditasa");

	void* sensor_data = malloc(1000);

	ALooper* looper = ALooper_forThread();

	if (looper == NULL) {
		looper = ALooper_prepare(ALOOPER_PREPARE_ALLOW_NON_CALLBACKS);
	}

	engine.sensorManager = ASensorManager_getInstance();
	engine.lightSensor = ASensorManager_getDefaultSensor(engine.sensorManager,
			ASENSOR_TYPE_LIGHT);
	engine.sensorEventQueue = ASensorManager_createEventQueue(
			engine.sensorManager, looper, 1, get_sensor_data, sensor_data);

	ASensorEventQueue_enableSensor(engine.sensorEventQueue, engine.lightSensor);

	// Mintavteli gyakorisg: 100Hz, utols paramter microsec-ben
	ASensorEventQueue_setEventRate(engine.sensorEventQueue, engine.lightSensor,
			100000);
}

void Java_hu_bute_daai_amorg_examples_NativeSensorLib_stopLightSensor() {
	LOGI("Light sensor leallitva");
	if (engine.lightSensor != NULL) {
		ASensorEventQueue_disableSensor(engine.sensorEventQueue,
				engine.lightSensor);
	}
}

int get_sensor_data(int fd, int events, void* data) {
	ASensorEvent event;
	while (ASensorEventQueue_getEvents(engine.sensorEventQueue, &event, 1) > 0) {
		if (event.type == ASENSOR_TYPE_LIGHT) {
			lightValue = event.light;
			LOGI("Light sensor value: %f", lightValue);
		}

	}
	// 1-el val visszatrs esetn jbl meghvdnak a callback-ek, 0 esetn nem (unregister)
	return 1;
}
