package hu.bute.daai.amorg.examples;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class NativeSensorDemoActivity extends Activity {
	private NativeSensorLib nativeLib;
	private TextView tvStatus;
	private Handler mHandler = new Handler();
	private boolean lightSensorEnabled = true;

	private final Runnable mRunnable = new Runnable() {
		public void run() {
			if (lightSensorEnabled) {
				float lightValue = nativeLib.getLightSensorValue();
				tvStatus.setText("Light sensor value: "+lightValue);
				mHandler.postDelayed(mRunnable, 200);
			}
		}
	};
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        nativeLib = new NativeSensorLib();
        
        tvStatus = (TextView)findViewById(R.id.tvStatus);
        
        Button btnStartLight = (Button)findViewById(R.id.btnStartLight);
        btnStartLight.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				nativeLib.startLightSensor();
				lightSensorEnabled = true;
				mHandler.postDelayed(mRunnable, 200);
			}
		});
        Button btnStopLight = (Button)findViewById(R.id.btnStopLight);
        btnStopLight.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				tvStatus.setText("");
				lightSensorEnabled = false;
				nativeLib.stopLightSensor();
			}
		});
    }

	@Override
	protected void onStop() {
		super.onStop();
		if (lightSensorEnabled) {
			lightSensorEnabled = false;
			nativeLib.stopLightSensor();
		}
	}
}