package hu.bute.daai.amorg.examples;

import android.app.Activity;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class ActivityNotificationExample extends Activity {
	
	private static final int NOTIFICATION_ID = 1;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        Button btnShowNotification = (Button) findViewById(R.id.btnShowNotification);
        btnShowNotification.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				showNotification();
			}
		});
    }
    
	public void showNotification()
	{
		NotificationManager mNotificationManager =
			(NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
		
		Intent notificationIntent =
			new Intent(this, ActivityNotificationExample.class);
		PendingIntent contentIntent =
			PendingIntent.getActivity(this, 0,
					notificationIntent, 0);
	
		// Notificationobjektum sszelltsa
		Notification notification =
			new Notification(R.drawable.icon,
					"Notification cimsor",
					System.currentTimeMillis());
		notification.defaults |= Notification.DEFAULT_SOUND;
		notification.defaults |= Notification.DEFAULT_VIBRATE;
		notification.setLatestEventInfo(this,
				"Notification cim", "Notification szoveg",
				contentIntent);
		
		mNotificationManager.notify(NOTIFICATION_ID,
				notification);
	}
}