package hu.bute.daai.amorg.examples;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.Socket;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class SocketDemoActivity extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        Button btnSocketDemo = (Button)findViewById(R.id.btnSocketDemo);
        btnSocketDemo.setOnClickListener(new OnClickListener() {
			public void onClick(View arg0) {
				new Thread() {
					public void run()
					{
						socketDemo();
					}
				}.start();
			}
		});
    }
    
	private void socketDemo() {
		Socket socket = null;
		InputStream is = null;
		OutputStream os = null;
		try {
			socket = new Socket("217.20.130.97",80);
			socket.setSoTimeout(10000);
			
			os = socket.getOutputStream();
			os.write("GET index.html HTTP/1.0\n".getBytes());
			os.write("From: john@doe.com\n".getBytes());
			os.write("User-Agent: AndroidBook/1.0\n".getBytes());
			os.write("\n".getBytes());
			os.flush();
			
			is = socket.getInputStream();
			
			InputStreamReader isr = new InputStreamReader(is, "UTF-8");
			StringBuilder resultBuffer = new StringBuilder();
			int inChar;
			while ((inChar = isr.read()) != -1) {
			  resultBuffer.append((char) inChar);
			}
			final String result = resultBuffer.toString();
			
			runOnUiThread(new Runnable() {
				public void run() {
					Toast.makeText(SocketDemoActivity.this, result, Toast.LENGTH_LONG).show();
				}
			});
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (os != null)
				try {
					os.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			if (is != null)
				try {
					is.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			if (socket != null)
				try {
					socket.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
		}
	}
}