package hu.bute.daai.amorg.examples;

import android.app.Activity;
import android.net.TrafficStats;
import android.os.Bundle;
import android.os.Handler;
import android.widget.TextView;

public class TrafficStatsDemoActivity extends Activity {

	private TextView tvDownload;
	private TextView tvUpload;
	private Handler mHandler = new Handler();

	private final Runnable mRunnable = new Runnable() {
		public void run() {
			long rxBytes = TrafficStats.getMobileRxBytes();
			tvDownload.setText(Long.toString(rxBytes));
			long txBytes = TrafficStats.getMobileTxBytes();
			tvUpload.setText(Long.toString(txBytes));
			mHandler.postDelayed(mRunnable, 1000);
		}
	};

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		tvDownload = (TextView) findViewById(R.id.tvDownload);
		tvUpload = (TextView) findViewById(R.id.tvUpload);

		mHandler.postDelayed(mRunnable, 1000);
	}
}