package hu.bute.daai.amorg.examples;

import java.util.Date;

import android.graphics.Canvas;
import android.graphics.Paint;
import android.service.wallpaper.WallpaperService;
import android.view.MotionEvent;
import android.view.SurfaceHolder;

public class MyWallpaper extends WallpaperService {
	@Override
	public void onCreate() {
		super.onCreate();
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
	}

	@Override
	public Engine onCreateEngine() {
		return new CubeEngine();
	}
	
	class CubeEngine extends Engine {
		private final Paint mPaint = new Paint();
		private float mTouchX = 0;
		private float mTouchY = 0;
		
		CubeEngine() {
			final Paint paint = mPaint;
			paint.setColor(0xffffffff);
			paint.setTextSize(25);
		}

		@Override
		public void onCreate(SurfaceHolder surfaceHolder) {
			super.onCreate(surfaceHolder);
			// rints esemnyre kezels jelzse
			setTouchEventsEnabled(true);
		}

		@Override
		public void onTouchEvent(MotionEvent event) {
			super.onTouchEvent(event);

			if (event.getAction() == MotionEvent.ACTION_UP) {
				mTouchX = -1;
				mTouchY = -1;
			} else {
				mTouchX = event.getX();
				mTouchY = event.getY();
			}
			drawFrame();
		}

		void drawFrame() {
			final SurfaceHolder holder = getSurfaceHolder();
			Canvas c = null;
			try {
				c = holder.lockCanvas();
				if (c != null) {
					c.save();
					c.drawColor(0xff000000);
					c.drawText(new Date(System.currentTimeMillis())
							.toLocaleString(), mTouchX, mTouchY, mPaint);
					c.restore();
				}
			} finally {
				if (c != null)
					holder.unlockCanvasAndPost(c);
			}
		}
	}
} // osztly bezrsa
