package hu.bute.daai.amorg.examples;

import android.app.Activity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.webkit.JsResult;
import android.webkit.WebChromeClient;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.ProgressBar;
import android.widget.TextView;

public class WebViewDemoActivity extends Activity {
	
	private WebView mWebView;
	private ProgressBar progressBarWebLoad;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        final TextView tvStatus = (TextView)findViewById(R.id.tvStatus);
        progressBarWebLoad = (ProgressBar)findViewById(R.id.progressBarWebLoad);
        progressBarWebLoad.setMax(100);
        
        
        mWebView = (WebView)findViewById(R.id.webView);
        mWebView.getSettings().setBuiltInZoomControls(true);
        mWebView.getSettings().setJavaScriptEnabled(true);
        
		mWebView.setWebViewClient(new WebViewClient() {
			@Override
			public void onReceivedError(WebView view,
					int errorCode, String description,
					String failingUrl) {
				// Hiba kezelse
			}
		
			@Override
			public boolean shouldOverrideUrlLoading(
					WebView view, String url) {
				loadSite(url);
				return true;
			}
			
			@Override
			public void onPageFinished(WebView view, String url) {
        		progressBarWebLoad.setProgress(100);
        		progressBarWebLoad.setVisibility(View.GONE);
				super.onPageFinished(view, url);
			}
		});
        
        mWebView.setWebChromeClient(new WebChromeClient() {
        	@Override
        	public void onProgressChanged(WebView view,
    			int progress) {
        		tvStatus.setText("Progress: "+progress);
        		progressBarWebLoad.setProgress(progress);
        	}
        	
        	@Override
            public boolean onJsAlert(WebView view, String url,
            		String message,JsResult result) {
        		tvStatus.setText("JS Alert: "+message);
                // return true; esetn nem fut le a default
        		// implementci (pop-up ablak)
        		return true;
        		//return super.onJsAlert(view, url, message, result);
            }

        });
        
        //loadSite("http://avalon.aut.bme.hu/~tyrael/webview/jsalert.html");
        loadSite("http://amorg.aut.bme.hu");
    }
    
    private void loadSite(String aURL) {
    	progressBarWebLoad.setVisibility(View.VISIBLE);
    	progressBarWebLoad.setProgress(0);
    	mWebView.loadUrl(aURL);
    }

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if ((keyCode == KeyEvent.KEYCODE_BACK) && 
				mWebView.canGoBack()) {
			progressBarWebLoad.setVisibility(View.VISIBLE);
	    	progressBarWebLoad.setProgress(0);
            mWebView.goBack();
            return true; // ne legyen vissza esemny
        }
        return super.onKeyDown(keyCode, event);
	}
}