package hu.bute.daai.amorg.examples;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class WifiScanActivity extends Activity {

	private TextView tvStatus;
	private WifiManager wifiManager;

	private BroadcastReceiver wifiStateChangedReceiver = new BroadcastReceiver() {
		@Override
		public void onReceive(Context context, Intent intent) {
			for (ScanResult result : wifiManager.getScanResults()) {
				tvStatus.append("\n" + result.SSID);
			}
		}
	};

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		tvStatus = (TextView) findViewById(R.id.tvStatus);
		wifiManager = (WifiManager) getSystemService(Context.WIFI_SERVICE);

		Button btnStartScan = (Button) findViewById(R.id.btnStartScan);
		btnStartScan.setOnClickListener(new OnClickListener() {
			public void onClick(View arg0) {
				tvStatus.setText("");
				wifiManager.startScan();
			}
		});

		registerReceiver(wifiStateChangedReceiver, new IntentFilter(
				WifiManager.SCAN_RESULTS_AVAILABLE_ACTION));
	}

	@Override
	protected void onStop() {
		super.onStop();
		unregisterReceiver(wifiStateChangedReceiver);
	}
}